/* db_vmheap.c - string heap manager
 *
 * Copyright (c) 2009 by David Michael Betz.  All rights reserved.
 *
 */

#ifndef __DB_VMHEAP_H__
#define __DB_VMHEAP_H__

#include "db_vm.h"

/* string handle structure */
typedef struct {
    uint8_t *data;
} StringHandle;

/* string heap structure */
typedef struct {
    int nHandles;               /* number of handles */
    StringHandle *handles;      /* array of handles */
    StringHandle *freeHandles;  /* list of free handles */
    uint8_t *data;              /* heap data */
    uint8_t *free;              /* next free heap location */
} StringHeap;

void InitHeap(StringHeap *heap, uint8_t *data, uint16_t size, uint16_t nHandles);
StringHandle *StringAlloc(StringHeap *heap, uint16_t length);
void StringAddRef(StringHandle *handle);
void StringRelease(StringHeap *heap, StringHandle *handle);

#endif
